routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
#### TEST ####

Route::group(['prefix' => '/test'], function () {
  Route::get('/getCities', 'TestController@getCities')->name('test.cities');
});


#### SITE ####


#### PAYMENT ####

Route::group(['prefix' => 'payments'], function () {
  Route::group(['prefix' => 'checkout'], function () {
    Route::get('liqpay', 'PaymentController@payViaLiqPay')->name('pay.checkout.liqpay');
  });

  Route::group(['prefix' => 'callback'], function () {
    Route::get('liqpay', 'PaymentController@callbackTransactionViaLiqPay')->name('pay.callback.liqpay');
  });

  Route::group(['prefix' => 'listener'], function () {
    Route::match(['GET', 'POST'], 'liqpay', 'PaymentController@listenerTransactionViaLiqPay')->name('pay.listener.liqpay');
  });
});

#### PAYMENT ####


Route::get('/', 'MainController@index')->name('site.home');

#### PRODUCTS ####

Route::group(['prefix' => 'products'], function () {
  Route::get('/', 'ProductController@index')->name('site.products.index');
  Route::get('/{product:alias}', 'ProductController@show')->name('site.products.show');
  Route::post('/order', 'ProductController@order')->name('site.products.order');
});

#### PRODUCTS ####

#### CART ####

Route::group(['prefix' => 'cart'], function () {
  #### PAGES ####

  Route::get('/', 'CartController@index')->name('cart.index');
  Route::get('/confirm', 'CartController@confirm')->name('cart.confirm');

  #### PAGES ####

  #### ITEMS ####

  Route::put('/edit-item/{orderProduct}', 'CartController@editItem')->name('cart.editItem');
  Route::delete('/delete-item/{orderProduct}', 'CartController@deleteItem')->name('cart.deleteItem');

  #### ITEMS ####

  Route::post('/checkout', 'CartController@checkout')->name('cart.checkout');

  Route::get('/success', 'CartController@success')
    ->name('cart.success')
    ->middleware(\App\Http\Middleware\FlashSuccessOrderMiddleware::class);
});

#### CART ####

#### STATIC ####

Route::get('/about', 'StaticController@about')->name('about');
Route::get('/contacts', 'StaticController@contacts')->name('contacts');
Route::get('/faq', 'StaticController@faq')->name('faq');
Route::get('/delivery', 'StaticController@delivery')->name('delivery');
Route::get('/warranty', 'StaticController@warranty')->name('warranty');
Route::get('/back-product', 'StaticController@backProduct')->name('backProduct');

#### STATIC ####

#### SITE ####


#### ADMIN PANEL ####

Route::get('login', 'Auth\LoginController@showLoginForm')->name('login');
Route::post('login', 'Auth\LoginController@login');
Route::post('logout', 'Auth\LoginController@logout')->name('logout');


Route::get('/admin', 'HomeController@index')->name('home');

Route::group(['prefix' => '/admin', 'middleware' => 'auth', 'namespace' => 'Admin'], function () {

  #### CATEGORY ####

  Route::resource('categories', 'CategoryController');
  Route::group(['prefix' => '/categories'], function () {
    Route::post('/reorder', 'CategoryController@reorder');
  });

  #### CATEGORY ####

  #### SUBCATEGORY ####

  Route::resource('sub-categories', 'SubCategoryController');
  Route::group(['prefix' => '/sub-categories'], function () {
    Route::post('/reorder', 'SubCategoryController@reorder');
  });

  #### SUBCATEGORY ####

  #### ATTRIBUTES ####

  Route::resource('attributes', 'AttributeController');
  Route::group(['prefix' => '/attributes'], function () {
    Route::post('/reorder', 'AttributeController@reorder');
  });

  #### ATTRIBUTES ####

  #### ATTRIBUTE OPTIONS ####

  Route::resource('attribute-options', 'AttributeOptionController');
  Route::group(['prefix' => '/attribute-options'], function () {
    Route::post('/reorder', 'AttributeOptionController@reorder');
  });

  #### ATTRIBUTE OPTIONS ####

  #### PRODUCTS ####

  Route::resource('products', 'ProductController');
  Route::group(['prefix' => '/products'], function () {
    Route::post('/reorder', 'ProductController@reorder');
    Route::post('/reorder-picture', 'ProductController@reorderPictures');
  });

  #### PRODUCTS ####

  #### ORDERS ####

  Route::group(['prefix' => 'orders'], function () {
    Route::get('/', 'OrderController@index')->name('orders.index');
    Route::post('/{order}/accept', 'OrderController@accept')->name('order.accept');
    Route::post('/{order}/confirmed', 'OrderController@confirmed')->name('order.confirmed');
    Route::post('/{order}/canceled', 'OrderController@canceled')->name('order.canceled');
  });

  #### ORDERS ####

  #### SEO ####

  Route::resource('seo', 'SeoController')->except([
    'show'
  ]);

  #### SEO ####

});

#### ADMIN PANEL ####

app/Models/Category.php
<?php

namespace App\Models;

use App\Models\Helpers\CriteriaActions;
use App\Models\Helpers\ReorderRecord;
use App\Models\Mixins\CategoryMixin;
use App\Models\Scopes\CategoryScopes;
use Cviebrock\EloquentSluggable\Sluggable;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Collection;
use Illuminate\Database\Eloquent\SoftDeletes;

/**
 * Class Category
 * @package App\Models
 *
 * @property integer $id
 * @property string $alias
 * @property string $title
 * @property int $display_order
 * @property string $seo_title
 * @property string $seo_description
 *
 * @property Product[]|Collection $product
 * @property Category[]|Collection $subCategory
 */
class Category extends Model {
  use CriteriaActions, CategoryScopes, CategoryMixin, ReorderRecord, Sluggable, SoftDeletes;

  /**
   * @var string
   */
  protected $table = 'categories';

  /**
   * @var array
   */
  protected $fillable = [
    'alias',
    'title',
    'display_order',
    'seo_title',
    'seo_description',
  ];

  /**
   * @var array
   */
  protected $casts = [
    'alias' => 'string',
    'title' => 'string',
    'display_order' => 'int',
    'seo_title' => 'string',
    'seo_description' => 'string',
  ];

  /**
   * Generate an alias
   *
   * @return array|\string[][]
   */
  public function sluggable(): array {
    return [
      'alias' => [
        'source' => 'title',
      ],
    ];
  }

  /**
   * Get products for the category.
   *
   * @return \Illuminate\Database\Eloquent\Relations\HasMany
   */
  public function products() {
    return $this->hasMany(Product::class, 'category_id', 'id');
  }

  /**
   * Get sub categories for the category.
   *
   * @return \Illuminate\Database\Eloquent\Relations\HasMany
   */
  public function subCategories() {
    return $this->hasMany(SubCategory::class, 'category_id', 'id');
  }
}

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\ReorderRecordFormRequest;
use App\Services\Actions\CategoryServiceAction;
use Illuminate\Http\RedirectResponse;
use App\Models\Category;
use Illuminate\View\View;
use App\Http\Requests\CategoryRequest;

class CategoryController extends Controller {
  /**
   * @var CategoryServiceAction
   */
  protected $service;

  /**
   * CategoryController constructor.
   *
   * @param CategoryServiceAction $service
   */
  public function __construct(CategoryServiceAction $service) {
    $this->service = $service;
  }

  /**
   * @return View
   */
  public function index(): View {
    $categories = Category::query()
      ->orderBy('display_order', 'asc')
      ->get();

    return view('admin.categories.index', [
      'categories' => $categories,
    ]);
  }

  /**
   * @return View
   */
  public function create(): View {
    return view('admin.categories.edit', [
      'category' => new Category(),
    ]);
  }

  /**
   * @param CategoryRequest $request
   * @return RedirectResponse
   */
  public function store(CategoryRequest $request) {
    $this->service->createCategory($request->createDto());
    return redirect()
      ->route('categories.index')
      ->with(['message' => 'Категория сохранена.', 'class' => 'success']);
  }

  /**
   * @param Category $category
   * @return View
   */
  public function edit(Category $category): View {
    return view('admin.categories.edit', [
      'category' => $category,
    ]);
  }

  /**
   * Update the specified resource in storage.
   *
   * @param Category $category
   * @param CategoryRequest $request
   * @return RedirectResponse
   */
  public function update(Category $category, CategoryRequest $request) {
    $this->service->updateCategory($category, $request->createDto());

    return redirect()->route('categories.index')->with([
      'message' => 'Категория изменена.',
      'class' => 'success'
    ]);
  }

  /**
   * @param Category $category
   * @return RedirectResponse
   * @throws \Exception
   *
   */
  public function destroy(Category $category) {
    $category->delete();
    return redirect()->route('categories.index')->with([
      'class' => 'success',
      'message' => 'Категория успешно удалена.',
    ]);
  }

  /**
   * @param ReorderRecordFormRequest $request
   * @return \Illuminate\Http\JsonResponse
   */
  public function reorder(ReorderRecordFormRequest $request) {
    if ($this->service->reorder((int)$request->json('currentId'), (int)$request->json('desiredId'), Category::class)) {
      return response()->json(['status' => 'reorder']);
    }

    return response()->json(['error' => 'Категория не найдена'], 404);
  }
}

resources/views/admin/categories/edit.blade.php
<?php
/* @var array $errors */
/* @var \App\Models\Category $category */
?>

@extends('admin.layouts.app')

@section('content')
  <div class="container">
    <br>
    <div class="row">
      <div class="col-12">
        <a href="{{ route('categories.index') }}" class="btn btn-sm btn-secondary">Назад</a>
      </div>
    </div>
    <div class="row">
      <div class="col-12">
        <form method="POST"
              @if($category->exists)
              action="{{ route('categories.update', ['category' => $category]) }}"
              @else
              action="{{ route('categories.store') }}"
              @endif
              enctype='multipart/form-data'>
          @csrf
          @if($category->exists)
            @method('PUT')
          @endif
          @component('admin.includes.formGroup', ['errors' => $errors, 'property' => 'title', 'label' => 'Категория'])
            <input type="text" required class="form-control" name="title" id="inputTitle"
                   value="{{ old('title') ? old('title') : $category->title }}">
          @endcomponent

          @component('admin.includes.formGroup', ['errors' => $errors, 'property' => 'seo_title', 'label' => 'seo_title'])
            <input type="text" class="form-control" name="seo_title" id="inputTitle"
                   value="{{ old('seo_title') ? old('seo_title') : $category->seo_title }}">
          @endcomponent

          @component('admin.includes.textarea_input', [
              'name' => 'seo_description',
              'label' => 'Seo description',
              'placeholder' => 'Введите seo description',
              'object' => !$category->isNew() ? $category : null,
              'rows' => 5,
              'width' => 'col-sm-12'
          ])@endcomponent
          <br>
          <div class="form-group row">
            <div class="col-sm-10">
              <button type="submit" class="btn btn-sm btn-success">Сохранить</button>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>
@endsection

resources/views/admin/categories/index.blade.php
<?php
/* @var \App\Models\Category[] $categories */
?>

@extends('admin.layouts.app')

@section('content')
  <div class="container">
    <div class="row">
      <div class="col-12">
        <h2>Категории</h2>
      </div>
    </div>
    <div class="buttons">
      <div class="button-group form-group">
        <a href="{{ route('categories.create') }}">
          <button type="button" class="btn btn-sm btn-success"><i class="fa fa-pencil" aria-hidden="true"></i> Создать
          </button>
        </a>
      </div>
    </div>
    <br>
    <div class="row">
      <div class="col-12">
        <table id="sortable" class="table table-striped">
          <thead>
          <tr>
            <th scope="col">#</th>
            <th scope="col">Название</th>
            <th scope="col">alias</th>
            <th scope="col"></th>
            <th scope="col"></th>
          </tr>
          </thead>
          <tbody>

          @foreach($categories as $i => $category)
            <tr data-index="{{ $i }}" data-id="{{ $category->id }}" data-entity="{{ $category->getTable() }}">
              <th scope="row">{{ $loop->index + 1 }}</th>
              <td>
                {{ $category->title }}</td>
              <td>{{ $category->alias }}</td>
              <td>
                <a href="{{ route('categories.edit', ['category' => $category])}}"
                   data-toggle="tooltip" title="Редактировать">
                  <i class="fa fa-pencil-square-o" aria-hidden="true"></i>
                </a>
              </td>
              <td>
                <form action="{{route('categories.destroy',['category' => $category])}}" method="POST">
                  @method('DELETE')
                  @csrf
                  <button data-toggle="tooltip" onclick="return confirm('Вы действительно хотите удалить?')" class="fa fa-trash" aria-hidden="true"></button>
                </form>
              </td>
            </tr>
          @endforeach

          </tbody>
        </table>

      </div>
    </div>
  </div>
@endsection

@section('scripts')
  <script type="text/javascript" src="{{ \EscapeWork\Assets\Facades\Asset::v('js/sortable.js') }}"></script>
@endsection